config/routes.rb
require 'api_constraints'
RiseRp::Application.routes.draw do
  
  root 'pages#index'  

  get :search, to: 'resources#search'

  resources :collections do
    collection do 
      get :import
    end
    resources :resources, controller: 'collections/resources' do
      collection do
        get :import
      end
    end
  end

  resources :resources do
    resources :sections, controller: 'resources/sections' do
      collection do
        get :import
      end
    end
  end

  resources :sections, controller: 'resources/sections' do
    resources :content_units, controller: 'sections/content_units' do
      collection do
        get :import
      end
    end
  end

  resources :pages do
    collection do
      get :home
      get :help
    end
  end

  namespace :api, defaults: { format: :json } do
    scope module: :v1, constraints: ApiConstraints.new(version: 1, default: true) do
      get :search, param: :q, to: 'resources#search'
      resources :collections, param: :uuid, only: %i{index show} do
        resources :resources, only: %i{index}, controller: 'collections/resources' do
        end
      end
      resources :resources, param: :uuid, only: %i{index show} do
        member do
          get :metadata
        end
        resources :sections, only: %i{index}, controller: 'resources/sections'
      end
      resources :sections, param: :uuid, only: %i{index show} do
        member do
          get :metadata
        end
        resources :content_units, only: %i{index}, controller: 'sections/content_units' do
        end
      end
      resources :content_units, param: :uuid, only: %i{show} do
        member do
          get :metadata
        end
      end
    end
  end
end

app/models/collection.rb
# == Schema Information
#
# Table name: collections
#
#  id          :bigint(8)        not null, primary key
#  uuid        :uuid             not null
#  name        :string
#  metadata    :jsonb            not null
#  import_type :integer          default("script")
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#

class Collection < ApplicationRecord
  paginates_per 50
  include UuidFindable
  default_scope { order(name: :asc) }

  has_many :resources, inverse_of: :collection, dependent: :destroy
  has_many :sections, through: :resources, dependent: :destroy
  has_many :content_units, through: :resources, dependent: :destroy

  IMPORT_TYPES = { script: 0, folder: 1, views: 2 }.freeze

  enum import_type: IMPORT_TYPES

  def to_s
    name
  end

  def check_and_parse!
    case import_type.to_sym
    when :script
    when :folder
      section_ids = self.sections.map(&:id)
      ContentUnit.where(section_id: section_ids).delete_all
      Section.where(id: section_ids).delete_all
      self.resources.delete_all
      self.reload
      cfp = CollectionFolderParser.new(self)
      cfp.create_hierarchy
      cfp.add_metadata
      ContentUnit.reindex
    when :views
    end
  end

  def resource_count
    resources.count
  end
end

app/controllers/api/v1/collections/resources_controller.rb
module Api
  module V1
    module Collections
      class ResourcesController < Api::ApiController
        before_action :set_collection, only: %i{index}

        def index
          render json: @collection.resources, each_serializer: CollectionResourceSerializer
        end

        private

        def set_collection
          @collection = Collection.from_uuid(params[:collection_uuid])
        end
      end
    end
  end
end

app/controllers/api/v1/collections_controller.rb
module Api
  module V1
    class CollectionsController < Api::ApiController
      before_action :set_collection, only: %i{show}
      def index
        render json: Collection.all
      end

      def show
        render json: @collection
      end

      private

      def render_errors
        render json: { errors: @collection.errors }, status: :unprocessable_entity
      end

      def set_collection
        @collection = Collection.from_uuid(params[:uuid])
      end
    end
  end
end

app/controllers/collections/resources_controller.rb
module Collections
  class ResourcesController < ApplicationController
    before_action :set_collection, only: %i[index edit update import new create destroy]
    before_action :set_resource, only: %i[show edit update destroy]
  
    def index
    	@resources = @collection.resources.page params[:page]
    end

    def search
      @q = params[:q]
      @content_units = ContentUnit.search @q, page: params[:page], per_page: 20, highlight: true, includes: {section: {resource: :collection}}
    end
  
    def import
    end
  
    def show; end
  
    def new
      @resource = Resource.new
    end
  
    def edit; end
  
    def create
      @resource = @collection.resources.build(resource_params)
      if @resource.save
        redirect_to [@collection, Resource], notice: 'Resource was successfully created.'
      else
        render :new
      end
    end
  
    def update
      if @resource.update(resource_params)
        redirect_to [@collection, :resources], notice: 'Resource was successfully updated.'
      else
        render :edit
      end
    end
  
    def destroy
      @resource.destroy
      redirect_to [@collection, :resources], notice: 'Resource deleted'
    end
  
    def set_collection
      @collection = Collection.find(params[:collection_id])
    end

    def set_resource
      @resource = Resource.find(params[:id])
    end
  
    def resource_params
      params.fetch(:resource, {}).permit(:name, :collection_id)
    end
  end
end

app/controllers/collections_controller.rb
class CollectionsController < ApplicationController
  before_action :set_collection, only: %i[show edit update destroy]

  def index
  	@collections = Collection.all.page params[:page]
  end

  def import
  end

  def show; end

  def new
    @collection = Collection.new
  end

  def edit; end

  def create
    @collection = Collection.new(collection_params)
    if @collection.save
      @collection.check_and_parse!
      redirect_to [Collection], notice: 'Collection was successfully created.'
    else
      render :new
    end
  end

  def update
    if @collection.update(collection_params)
      @collection.check_and_parse!
      redirect_to Collection, notice: 'Collection was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    @collection.destroy
    redirect_to Collection, notice: 'Collection deleted'
  end

  def set_collection
    @collection = Collection.find(params[:id])
  end

  def collection_params
    params.fetch(:collection, {}).permit(:name, :import_type, :import_folder)
  end
end

app/helpers/collections_helper.rb
module CollectionsHelper
end

app/views/collections/_form.html.haml
= simple_form_for(@collection) do |f|
  = f.error_notification
  = f.input :name
  = f.input :import_type, include_blank: false, collection: Collection::IMPORT_TYPES
  = f.input :import_folder
  = f.button :button, type: :submit, class: 'btn btn-primary'



    

app/views/collections/edit.html.haml
.d-flex.justify-content-between.flex-wrap.flex-md-nowrap.align-items-center.pb-2.mb-3
  %h1.h2 Edit Collection
= render 'form'

app/views/collections/index.html.haml
.d-flex.justify-content-between.flex-wrap.flex-md-nowrap.align-items-center.pb-2.mb-3
  %h1.h4 Collections
  .btn-toolbar.mb-2.mb-md-0
    .btn-group.mr-2
      = link_to new_collection_path, class: 'btn btn-sm btn-outline-secondary' do
        %span{"data-feather" => "plus"}
        New Collection
      = link_to import_collections_path, class: 'btn btn-sm btn-outline-secondary' do 
        %span{"data-feather" => "upload"}
        Import
.table-responsive
  %table.table.table-striped.table-sm
    %thead
      %tr
        %th uuid
        %th Name
        %th Metadata
        %th Resource Count
        %th Actions
    %tbody
      - @collections.each do |collection|
        %tr
          %td= collection.uuid
          %td= collection.name
          %td= collection.metadata
          %td= collection.resources.size    
          %td
            .btn-group-vertical
              = link_to collection_resources_path(collection), class: 'btn btn-sm btn-outline-secondary' do
                %span{"data-feather" => "book"}
                Resources
              = link_to edit_collection_path(collection), class: 'btn btn-sm btn-outline-secondary' do
                %span{"data-feather" => "edit"}
                Edit
              = link_to collection, method: :delete, class: 'btn btn-sm btn-outline-secondary' do 
                %span{"data-feather" => "x-circle"}
                Delete

= paginate @collections, theme: 'twitter-bootstrap-4'

app/views/collections/new.html.haml
.d-flex.justify-content-between.flex-wrap.flex-md-nowrap.align-items-center.pb-2.mb-3
  %h1.h2 New Collection
= render 'form'